﻿using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RoadReport.UI
{
    /// <summary>
    /// Interaktionslogik für Report.xaml
    /// </summary>
    public partial class Report : UserControl
    {
        public Report(Objects.Datas _daten)
        {
            InitializeComponent();
            //mDataGrid.AutoGeneratingColumn += mDataGrid_AutoGeneratingColumn;
            this.DataContext = _daten;
        }

        //void mDataGrid_AutoGeneratingColumn(object sender, DataGridAutoGeneratingColumnEventArgs e)
        //{
        //    PropertyDescriptor _pd = (PropertyDescriptor)e.PropertyDescriptor;
        //    DisplayAttribute _da = (DisplayAttribute)_pd.Attributes[typeof(DisplayAttribute)];
        //    if (_da != null)
        //        e.Column.Header = _da.Name;
        //}

        private void DataGrid_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if (((DataGrid)sender).SelectedItem != null)
            {
                ((Objects.Data)((DataGrid)sender).SelectedItem).ZoomTo();
            }
        }

        private void Refresh_Click(object sender, RoutedEventArgs e)
        {
            Database db = HostApplicationServices.WorkingDatabase;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                SelectionSet Sset = cSelection.GetSelection();
                this.DataContext = new Objects.Datas(Sset, tr);
            }
        }
    }
}
